<template>
  <transition name="fade">
    <div v-if="data.show">
      <p>Hello from the dialog confirm</p>
      {{ title }}
      <button @click="_confirm">Confirm</button>
      <button @click="_cancel">Cancel</button>
    </div>
  </transition>
</template>

<script setup>
import { reactive } from 'vue';

const data = reactive({
  // Parameters that change depending on the type of dialogue
  title: undefined,
  message: undefined, // Main text content
  okButton: undefined, // Text for confirm button; leave it empty because we don't know what we're using it for
  cancelButton: 'Go Back', // text for cancel button
  show: false,

  // Private variables
  resolvePromise: undefined,
  rejectPromise: undefined
});

// const show = (opts = {}) => {
//   data.title = opts.title;
//   data.message = opts.message;
//   data.okButton = opts.okButton;
//   if (opts.cancelButton) {
//     data.cancelButton = opts.cancelButton;
//   }
//   // Once we set our config, we tell the popup modal to open
//   data.show = true;
//   // Return promise so the caller can get results
//   return new Promise((resolve, reject) => {
//     data.resolvePromise = resolve;
//     data.rejectPromise = reject;
//   });
// };

const _confirm = () => {
  data.show = false;
  data.resolvePromise(true);
};

const _cancel = () => {
  data.show = false;
  data.resolvePromise(false);
  // Or you can throw an error
  // this.rejectPromise(new Error('User cancelled the dialogue'))
};
</script>
